%  Copyright 2013 Ternarylogic LLC. All Rights Reserved
% title: scramlfsrbingal.m
% a binary LFSR scrambler of sequence sin1 in Galois configuration 
shifts=[1 0 0 1]+1; % the initial state of the shift register in origin 1
shifts-1          % display initial shift register content
sc1=[0 1;1 0]+1;  % the binary XOR function
sc3=sc1;
sc4=sc1;
ds4=sc1;
lent=size(outb1);
len=lent(2);
for i=1:len             % shift the bits of the LFSR 
    in=shifts(4);       % the output of SR3
    in3=shifts(3);      % the output of SR2 
    in1=shifts(1);       % the input symbol on sc1
    t3=sc3(in,in3);     % apply 'sc3'
    res1(i)=ds4(in,outb1(i));  % descrambled symbol in sequence
                               % on output
    on11=res1(i);        % the output of the descrambler
    t1=sc1(on11,in1);    % apply 'sc1'                          
    % shift symbols in the shift register
    shifts(4)=t3;        
    shifts(3)=shifts(2);
    shifts(2)=t1;      
    shifts(1)=outb1(i);    
end  
res1-1         % the sequence of descrambled symbols on the output
res1-sin1      % should be all zero if descrambled equence is same
               % as original sequence